#!/usr/bin/perl -w

################################INFO######################################
##
#		Blackmore's reactor 6.0-rc4 - script for X-Chat 
#		    Copyright (C) 2001-2003 Simeon Simeonov
#	
#	
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License 2 as published by
#       the Free Software Foundation
#
#       This program is distributed in the hope that it will be useful, but
#       WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#       General Public License (http://www.gnu.org/copyleft/gpl.html) 
#	for more details.
#
#       
#       If you have no access to read the license, write to the Free Software
#       Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
####

##
# Release date: 11.05.2003
##

## Changelog
# v 6.0-rc4 Added "disable <rule>" and "enable <rule>" arguments for the /reactor command
#
# v 6.0-rc3 Fixed a small bug causing unproper handleling of macros in $executable[x]
#	    (Thanks to Village)
#
# v 6.0-rc2 The script now loads the rules from an external file.
#           Added "list" and "reload" arguments for the /reactor command
#
# v 6.0-rc1 Bug causing the $source[x] line to allow any words to be triggered
#	    has been fixed (thanks to Joel Galenson)
#
# v 5.1  -  Macros can be used with $executable[x]
#
# v 5.0  -  New optional line ($executable[x])
#	 -  Added %e macros
#	 -  Some bugfixes
#	    Read the documentation for more details! 
#
# v 4.2  -  Contains a small bugfix 
#
# v 4.1	 -  $action[x] = 0; has been implemented 
#
# v 4.0  -  The script will now react on notice messages (/notice)
#        -  3 new optional lines ($source[x], $usource[x], $apply[x])
#        -  Flood protection system implemented
#
# v 3.0  -  The macros (most of them) can be used in the
#           trigger section of the rules ($word[x])
#        -  New optional line for the rule settings ($destination[x])
#        -  Write confirmation switch
#
# v 2.1  -  Added "status" argument for the /reactor command
# v.2.0  -  Added 3 new macros (%a, %d, %z) +login capability
#
# v.1.0  -  The first version of the script
##

## Intro: This script reacts to words or phrases said in the channel or on
# private. The script uses configuration rules defined by the user.
# The script can help you to define kick/ban words, public commands,
# ignore lame users, beep whenever somebody talks about you... you name it.
# The best thing with about this script is that you are in complete
# control by defining your own action rules. Blackmore's reactor has
# also its own macros. When you learn how to use this script, you will realize
# that you don't need some of the other X-Chat scripts you've been using
# until now.
##

## Installation: Copy this file to ~/.xchat/ and restart your X-Chat!
# The script has been tested on X-Chat 1.8.11 using the following systems:
# FreeBSD 4.8, GNU/Linux (RedHat 7.3)
# I don't know which older versions of X-Chat will support my script.
# I have not been able to test the script on X-Chat 2.* because I have not started using it.
# I will not make any attempts to make this script working under Windows
# 'cause I hate Microsoft and it's stupid OS.
# I am not responsible for versions of this script downloaded from
# other places then http://pichove.org:81/scripts.php (I'll soon switch to another provider)
##

## Background:  I'm a great fan of X-Chat, UNIX, GNU/Hurd and Perl. I've been
# trying to find script for X-Chat that does the same thing as
# this script. Finally I decided to write it myself. I hope that
# after this script is released some people will find it useful
# and will consider using X-Chat instead of mIRC (which SUX) or other
# stupid IRC-clients.
##

## Contact me:  I will try to describe the configuration and the rules
# setting as clearly as I can, but if you have any further questions,
# comments, ideas or simply find this script useful feel free to
# contact me (Blackmore) on #pichove - Undernet (http://pichove.org:81) [recommended]
# or send mail to: gueorgss@hinux.hin.no
# My PGP/GPG key can be downloaded from: http://pichove.org:81/blackmore.gpg
#
# N.B It is very important that you read the documentation before asking!!
##

## Downloading and checking for updates: My server is currently firewalled (port 80)
# by chello.no and I am forced to run it on port 81. I am about to change my provider.
# If you can't make contact with http://pichove.org:81/scripts.php, try http://pichove.org/scripts.php
# You can always get the latest version of the reactor script by joining #pichove - Undernet and typing: !reactor
# My bot (PurpleBOT) will DCC-send you the latest version of Blackmore's reactor.
##

## Thanks to:  chello.no for firewalling me/us (port 25, 80)
#  I don't know what to say.... Kids, think twice before choosing provider!!
#
# Yet again I wrote this script alone. If you find it useful and want me to
# continue developing it, please send me a mail or write something in the guestbook
# on my channel's page (where you downloaded the script). That will mean a lot to me.
##


##########################################################################
#############################CONFIGURATION################################
##########################################################################
# You have to reconfigure this script and make your own rules!

## The channel(s) where the script will "listen".
##  "" = all channels, "!#" = no channels (only listen for private messages)
## You can define active channels for each rule (se below!)
$chan = "#pichove";

## Command name. The name of the command which will enable|disable your script
## Default: reactor   Example: /reactor on - turns the script on /reactor off - turns the script off
## /reactor status - shows the current status of the script (on or off)
## /reactor list - lists the triggerwords for each rule you have defined
## /reactor reload - reloads the rules file. You can edit and reload your rules 
##  		     without having to restart the whole script
## /reactor disable <x> - disables rule x, where x is the number of the rule. <NEW>
##			  Disabled rule will not trigger any reaction until enabled.
##			  The ruke can be enabled by using /reactor enable <x>
##			  Using the "reload" argument will reload and reenable all rules.
## /reactor enable <x>	- enables the disabled rule x. Use /reactor list to see which rules <NEW>
##			  are enabled and which are disabled.

$command = "reactor";

## The name of the command which is used to write to a file
## Syntax: /<commandname> <filename> [text] 	<DEPRICATED>
$wcommand = "write";

## Rules file. The full path and filename of the file where you have defined your rules.
## If the file does not exists no error message will be given. No rules will be loaded.
$rules_file = "/home/blackmore/.xchat/rules.conf";

## Confirmation? 0 = no, 1 = yes
## If enabled the script will write confirmation every time the write command id used.
## Ex. /write test.log This is a test
## The script will display something like that: This is a test saved to /home/blackmore/test.log
## Those who have used v2.0, v2.1 of the script know what I am talking about. <DEPRICATED>
$confirm = 0;

## Autostart? Do you want the script to be turned on when X-Chat starts?
## 0 = no, 1 = yes
##N.B You can always start the script manually by typing /command on
$autostart = 1;

## Case sensitive? 0 = no, 1 = yes
## If set to 0 the script won't make difference between lower and uppercase letters
## if the word "test" is set as active word and case = 0 "test", "Test", "TeSt" will trigger the action
$case = 0;

## Flood protection
## How many times in 1 minute can a word be triggered before considered as flood?
$flimit = 4;


## N.B Remember to reconfigure your rules-file!! (rules.conf)
## rules.conf contains a detailed documentation for making rules and some useful examples
## The rules in this version are compatible with the rules from the previous versions.

########################## END OF CONFIGURATION###########################
#### Do *NOT* edit below this point if you are not familiar with Perl ####



$version = "v.6.0-rc4";
$flood = 0;

load_rules();

IRC::register("Blackmore's reactor", $version, "", "");
IRC::add_message_handler("PRIVMSG", "main_sub"); 
IRC::add_message_handler("NOTICE", "main_sub"); 
IRC::add_command_handler($command, "on_off"); 
IRC::add_command_handler($wcommand, "write_func");
IRC::add_timeout_handler(60000, "flood_sub");

sub load_rules {
	do $rules_file;
	for ($i = 0; $i < @word; $i++) {
		if (defined $word[$i]) { $enabled[$i] = 1; }
	}
}

sub write_func {

my ($capture) = @_;

        $capture =~ /(.*?) (.*)?/;
        my $arg = $1;
        my $rest = $2;
        if ($arg eq "") { IRC::print("Wrong command argument!! Syntax: /$wcommand <filename> <text>"); }
	if ( index ($arg, "/") != 0) {
                $arg = $ENV{HOME} . "/" . $arg;
        }
        
	unless (open (LOGFILE, ">>$arg")) {
        IRC::print("Sorry! You can not open/create $arg\n");
        
	} else {
        	print LOGFILE "$rest\n";
        	close (LOGFILE);
		if ($confirm == 1) {
        		IRC::print("$rest saved to $arg\n");
		}
        }
        return 1;

}


sub on_off {
	my ($capture) = @_;

	$capture =~ /(.*?) (.*)?/;
	my $arg1 = $1;
	my $arg2 = $2;

	SWITCH: for ($capture) {
		if (/on/) {
			$autostart = 1;
		        IRC::print("Script ON\n");
			last SWITCH;
			}

		if (/off/) {
                        $autostart = 0;
                        IRC::print("Script OFF\n");
                        last SWITCH;
                        }

		if (/status/) {
			if ($autostart == 1) { IRC::print("Blackmore's reactor is currently ON\n");}
			if ($autostart == 0) { IRC::print("Blackmore's reactor is currently OFF\n");}
			last SWITCH;
                        }

                if (/reload/) {
			@word = 0;
			@where = 0;
			@action = 0;
			@destination = 0;
			@apply = 0;
			@usource = 0;
			@source = 0;
			@executable = 0;
                        load_rules();
                        IRC::print("$rules_file reloaded.");
                        last SWITCH;
                }

                if (/list/) {
                        if (@word > 0) {
                                IRC::print("N -> Trigger -> Status");
                                IRC::print("____________");
                                IRC::print("\n");
                        }
                        for ($i = 0; $i < @word; $i++) {
                                if (defined $word[$i]) { 
					if ($enabled[$i] == 1) { IRC::print("$i -> $word[$i] -> enabled\n"); }
					else { IRC::print("$i -> $word[$i] -> disabled\n"); }
				}
                        }
                        last SWITCH;
                }

		if (/disable/) {
			if (($arg1 =~ /disable/) && ($arg2 =~ /([0-9])/)) {
				if (defined $word[$arg2]) {
					if ($enabled[$arg2] == 0) {
						IRC::print("Rule $arg2 already disabled\n");
					} else {
						$enabled[$arg2] = 0;
						IRC::print("$arg2 -> disabled\n");
					}
				} else {
					IRC::print("Rule $arg2 is not defined\n");
				}
				last SWITCH;
			}
		}

		if (/enable/) {
			if (($arg1 =~ /enable/) && ($arg2 =~ /([0-9])/)) {
				if (defined $word[$arg2]) {
					if ($enabled[$arg2] == 1) {
						IRC::print("Rule $arg2 already enabled\n");
					} else {
						$enabled[$arg2] = 1;
						IRC::print("$arg2 -> enabled\n");
					}
				} else {
					IRC::print("Rule $arg2 is not defined\n");
				}
				last SWITCH;
			}
		}



        IRC::print("Wrong command argument!! Syntax: /$command < on | off | status | list | reload | disable <num> | enable <num> >");
        }

return 1;
}



sub main_sub {

        if (($autostart == 1) && (($flood < $flimit) || ($flimit == 0))) {
	
		my ($line) = @_;
		
		$line =~ s/NOTICE/PRIVMSG/g;

		$line =~ m/\:(.*?)\!(.*?)\sPRIVMSG\s(.*?)\s\:(.*)?/;
      		my $nick = $1;
      		my $host = $2;
      		my $channel = $3;
      		my $text = $4;
		my ($bell) = "\a";
		my $me = IRC::get_info(1);
		my $server = IRC::get_info(3);
		my ($time) = `date "+%H:%M:%S"`;
		my ($date) = `date "+%d:%m:%y"`;
		chomp ($date);
		chomp ($time);

	
		for ($i = 0; $i < @word; $i++) {

			my $dest = $chan;
			if (defined $destination[$i]) {
				$dest = $destination[$i];
			}

	
			if ((($dest =~ /$channel/) || ($dest eq "") || ($channel eq $me)) && ($enabled[$i] == 1)) {
				$trig = 0;

				my ($temp2) = $word[$i];

				$temp2 =~ s/%n/$nick/g;
				$temp2 =~ s/%c/$channel/g;
				$temp2 =~ s/%h/$host/g;
				$temp2 =~ s/%s/$server/g;
				$temp2 =~ s/%m/$me/g;
				$temp2 =~ s/%z/$time/g;
				$temp2 =~ s/%d/$date/g;


				if (($where[$i] == 0) && ($channel ne $me)) { next; }
				if (($where[$i] == 1) && ($channel eq $me)) { next; }
				

				if (($case == 1) && (($text =~ /^$temp2\b/) || ($text =~ /\b$temp2\b/))) { $trig = 1; }
				if (($case == 0) && (($text =~ /^$temp2\b/i) || ($text =~ /\b$temp2\b/i))) { $trig = 1; }


                                if ((defined $apply[$i]) && ($channel ne $me)) {
                                        @access = IRC::user_list($channel, "");
                                        for ($j = 0; $j < @access; $j++) {

                                                if ($nick eq $access[$j]) {
                                                        $op = $access[$j + 2];
                                                        $voice = $access[$j + 3];
                                                }
                                        }

                                        SWITCH: for ($apply[$i]) {

                                                if (/0/) {
							unless (($op == 0) && ($voice == 0)) { $trig = 0; }
                                                        last SWITCH;
                                                 }

                                                if (/1/) {
							unless ((($op == 0) && ($voice == 0)) || (($op == 0) && ($voice == 1))) { $trig = 0; }	
                                                        last SWITCH;
                                                }

                                                if (/2/) {
							unless (($op == 0) && ($voice == 1)) { $trig = 0; }
                                                        last SWITCH;
                                                }

                                                if (/3/) {
							unless ((($op == 0) && ($voice == 0)) || ($op == 1)) { $trig = 0; }	
                                                        last SWITCH;
                                                }

                                                if (/4/) {
							unless (($voice == 1) || ($op == 1)) { $trig = 0; }	
                                                        last SWITCH;
                                                }

                                                if (/5/) {
							unless ($op == 1) { $trig = 0; }
                                                        last SWITCH;
                                                }
                                        }
                                }


				if (defined $source[$i]) {
					unless ((($source[$i]=~ /^$nick\b/i) || ($source[$i] =~/\b$nick\b/i)) && ($trig == 1)) { next; }
                                }

                                if (defined $usource[$i]) {
                                        if (($usource[$i]=~ /^$nick\b/i) || ($usource[$i] =~/\b$nick\b/i)) { next; }
                                }


				
				if ($trig == 1) {
				
					my ($capture) = $text;
					$capture =~ /$word[$i]\s+(\S+)/;
					my $arg = $1;
				
					if ($action[$i] eq "0") {
						return 1;
					}

					my ($temp) = $action[$i];
				
					$temp =~ s/%n/$nick/g;
					$temp =~ s/%c/$channel/g;
					$temp =~ s/%h/$host/g;
					$temp =~ s/%t/$text/g;
					$temp =~ s/%b/$bell/g;
					$temp =~ s/%s/$server/g;
					$temp =~ s/%m/$me/g;
					$temp =~ s/%w/$temp2/g;
					$temp =~ s/%z/$time/g;
					$temp =~ s/%d/$date/g;
					$temp =~ s/%a/$arg/g;
				
					if (defined $executable[$i]) {
						$execute = $executable[$i];
						$execute =~ s/%a/$arg/g;
						$execute =~ s/%n/$nick/g;
						$execute =~ s/%c/$channel/g;
						$execute =~ s/%t/$text/g;
						$execute =~ s/%s/$server/g;
						$execute =~ s/%m/$me/g;
						$execute =~ s/%w/$temp2/g;
						$execute =~ s/%z/$time/g;
						$execute =~ s/%d/$date/g;
						
						my (@exe) = `$execute`;
						my ($tmp) = "%e";

						if ($temp =~ /$tmp/) {
							my ($temp3) = $temp;
							for ($j = 0; $j < @exe; $j++) {
								$temp3 = $temp;
								my ($t) = $exe[$j];
								chomp($t);
								$temp3 =~ s/$tmp/$t/g;
								IRC::command("$temp3");
							}
						} else {
							IRC::command("$temp");
						}
					} else {
						IRC::command("$temp");
					}
					$flood++;
					IRC::add_timeout_handler(60000, "flood_sub");
				} ## if
			} ## $chan filter
		} ## for array
	} ## if $autostart
} ## main sub

sub flood_sub {
	$flood = 0;
	return 1;
}

IRC::print("Blackmore's reactor $version loaded!! Using $rules_file\n");
